;"This line left intentionally nonsense" - frisst der Assembler im List-File ;)
; ****************************************************************************
; *                             Projekt W006S003                             *
; *                     Firmware fr Geocaching-Magnetbake                   *
; *                        auf Atmel Tiny-AVR-Basis                          *
; ****************************************************************************
; *                                                                          *
; *                (c) 2009-2019 Jochen Wienstroth                           *
; *                wienstroth Elektronikentwicklung                          *
; *                Am Deutschherrenberg 33                                   *
; *                D-35578 Wetzlar                                           *
; *                Tel: auf Anfrage / Fax: 06441-445062                      *
; *                http://www.hw-entwickler.de                               *
; *                mailto: jw@hw-entwickler.de                               *
; *                                                                          *
; *                                                     2019-01-10           *
; *                                                                          *
; ****************************************************************************
; *                                                                          *
; *                Die Nutzung dieser Software ist nur erlaubt im            *
; *                Rahmen der Lizenz Creative Commons CC-BY-NC-SA            *
; *                V3.0 - siehe auch                                         *
; *                                                                          *
; *               http://creativecommons.org/licenses/by-nc-sa/3.0/          *
; *                                                                          *
; *                Jede Abweichung der Nutzung dieser Software               *
; *                von den genannten Bestimmungen darf nur                   *
; *                mit schriftlicher Genehmigung durch den oben              *
; *                genannten Urheberrechtsinhaber erfolgen !                 *
; *                                                                          *
; ****************************************************************************


.equ 	SWVER = 0x04          ;Firmware-Version

;                             Firmware-Historie:
;                             ==================


;	V0.04 (2019-01-10 *JWie*)
; Bugfix in Ausgaberoutine bzw. WTINT: der dazu fhrte dass Non-Multiplex-
; Betrieb nicht funktionierte.

;	V0.03 (2018-12-11 *JWie*)
;
; Implementierung von Funktionalitt als Reaktivlicht, Einblenden und Schrift
; auf dem Kopf (mit und ohne um 180 gedrehte 7Segment-Anzeige), 
; Display-Ansteuerung konfigurierbar nach Wunsch mit und ohne Multiplex 1:8
; im 1kHz-Timer1-IRQ.
; Bentigte Fuse-Settings: wie "Ab Werk", zustzlich Brown-Out-Detektor 
; auf 1,8V. Oder in Hex-Werten Low=0x62, High=0xDE, Extended=egal.

;	V0.02 (2012-11-12 *JWie*)
;
;  Displayansteuerung auf Multiplex-Verfahren im Timer1-IRQ 1kHz umgestellt,
;  damit immer nur noch noch ein einzelnes Segment angesteuert wird und damit
;  dann alle Zeichen gleich hell erscheinen - unabhngig davon, wieviele
;  Segmente in diesem Zeichen genutzt werden.
;
;  Weiterhin ausschlielich Magnetbaken-Funktionalitt, wer Reaktivlichter
;  will muss weiterhin mit anderer Leute Software in Basis-Koma rumwrgen.
;
;  ACHTUNG ! Neue Taktung erfordert andere Fuse-Settings als V0.01, jetzt
;  notwendig: Low=0x62, High=0xDE, Extended=egal.

;	V0.01 (2012-07-17 *JWie*)
;
;  Erste Version, ausschlielich Magnetbaken-Funktionalitt.

.equ    HWVER = 0x3001	     ;Hardware-Version

;                             Hardware-Historie:
;                             ==================

;   W006Z003V001 (2012-07-04 *JWie*)
;
;   Prototypen in THT nach Schaltplan "der Community" (TM), zustzlich
;   Benutzung von PA4/SCK zur Ansteuerung von SEG_DP, um den Dezimalpunkt
;   mitnutzen zu knnen.

.CSEG			                ;Code-Start		

;*****************************************************************************
;*****************************************************************************
;*                   Unterscheidung Entwicklung <-> Anwender                 *
;*****************************************************************************
;*****************************************************************************
;#define EW							; Entwickler kriegen Assembler-Quellcode
;*****************************************************************************
#ifdef EW
 .include "W006S003.asm"			; Entwickler kriegen Assembler-Quellcode,
#else
 .include "W6S3.inc"				; Anwender kriegen dot-deeh-double-youh
#endif
;*****************************************************************************


;*****************************************************************************
;*****************************************************************************
;*         Character-ROM fr Umwandlung ASCII-7Bit -> 7Segment               *
;*****************************************************************************
;*****************************************************************************
#include "CharROM.inc"			; "Character-ROM" einbinden fr bersetzung
								; ASCII 7-Bit nach 7Seg

;*****************************************************************************
;*****************************************************************************
;*                           Auszugebende Nachricht                          *
;*****************************************************************************
;*****************************************************************************
BOTBEG:							; Anfang auszugebende Nachricht
;*****************************************************************************
#ifndef	GENATDW					; Nachricht nur im Normalbetrieb einbauen
;*****************************************************************************
.equ FLCONF = 0b00010010        ; Konfigurationsbyte Flash
;               |||||||+--------- Bit0: reserviert, bitte 0 lassen
;               ||||||+---------- Bit1: MUX18, Mux 1:8 fr konst. Helligkeit
;               |||||+----------- Bit2: LDRTST, LDR-Test: Helligkeitsmessung
;               ||||+------------ Bit3: REAKTIV, 0=Magnetbake, 1=Reaktivlicht
;               |||+------------- Bit4: BLEND, Ausgabe per Segment-Einblendung
;               ||+-------------- Bit5: UPSDWN, Ausgabe "auf dem Kopf"
;               |+--------------- Bit6: JWUPSD, LD2 180 gedreht eingeltet
;               +---------------- Bit7: JWREAK, Reaktivlicht RC  la JWie

;.equ ADAUER = 80				; Anzeigedauer jedes Zeichens x10ms, (NORMAL)
.equ ADAUER = 5				    ; Einblendedauer pro Segment x10ms,  (BLEND)
								; Beispiel: 80 = 800ms Anzeigedauer

;.equ PDAUER = 5                ; Pausenzeit nach jedem Zeichen x10ms, (NORMAL)
.equ PDAUER = 60				; Haltezeit nach jedem Zeichen x10ms,  (BLEND)
                                ; Beispiel: 5 = 50ms Pausenzeit

.equ DSCHWELL = 48              ; Dunkel-Schwelle: Bei kleinerer Helligkeit
                                ; schaltet Reaktivlicht in Nachtmodus
.equ HSCHWELL = 128             ; Hell-Schwelle: Bei grerer Helligkeit
                                ; schaltet Reaktivlicht in Tagmodus
.equ SPRUNG = 5                 ; Sprunghhe: Hherer Sprung lst Reaktiv-
                                ; licht im Dunkelmodus aus.

.db FLCONF, ADAUER				; Flash-Config, Anzeigedauer ablegen
.db	PDAUER, DSCHWELL			; Pausen-Dauer, Dunkel-Schwelle ablegen
.db HSCHWELL, SPRUNG			; Hell-Schwelle, Sprunghhe ablegen

.dw ((BOTEND-BOTBEG-4)<<1)		; Lnge des Strings (automatisch errechnet) 
							
;*****************************************************************************
;                          Eigentlicher Ausgabe-String
;*****************************************************************************

.db "HALLO FINDE N48*51.493 E002*17.670 und H=324"	
.db "PIEPS "

;*****************************************************************************
;                       Ende eigentlicher Ausgabe-String
;*****************************************************************************

;*****************************************************************************
BOTEND:							; Ende von Ausgabestring
;*****************************************************************************
                                ; Ablage Versions-String zur Identifikation
	.db "W006S003V0",(SWVER/10)+'0',(SWVER%10)+'0'
;*****************************************************************************
#endif

;*****************************************************************************
;*****************************************************************************
;*                                PROGRAMM-ENDE                              *
;*****************************************************************************
;*****************************************************************************
